"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.print = exports.highlight = void 0;
const prism = require("prismjs");
const printTree_1 = require("tree-dump/lib/printTree");
require("prismjs/components/prism-clike");
require("prismjs/components/prism-c");
require("prismjs/components/prism-java");
require("prismjs/components/prism-json");
require("prismjs/components/prism-jsx");
require("prismjs/components/prism-javascript");
require("prismjs/components/prism-nix");
require("prismjs/components/prism-uri");
require("prismjs/components/prism-twig");
require("prismjs/components/prism-swift");
require("prismjs/components/prism-visual-basic");
require("prismjs/components/prism-sql");
require("prismjs/components/prism-solidity");
require("prismjs/components/prism-scss");
require("prismjs/components/prism-css");
require("prismjs/components/prism-scala");
require("prismjs/components/prism-ruby");
require("prismjs/components/prism-sass");
require("prismjs/components/prism-rest");
require("prismjs/components/prism-pug");
require("prismjs/components/prism-php");
require("prismjs/components/prism-pascal");
require("prismjs/components/prism-ocaml");
require("prismjs/components/prism-objectivec");
require("prismjs/components/prism-nginx");
require("prismjs/components/prism-mongodb");
require("prismjs/components/prism-matlab");
require("prismjs/components/prism-lua");
require("prismjs/components/prism-makefile");
require("prismjs/components/prism-llvm");
require("prismjs/components/prism-less");
require("prismjs/components/prism-jsonp");
require("prismjs/components/prism-json5");
require("prismjs/components/prism-groovy");
require("prismjs/components/prism-go");
require("prismjs/components/prism-rust");
require("prismjs/components/prism-haskell");
require("prismjs/components/prism-gradle");
require("prismjs/components/prism-graphql");
require("prismjs/components/prism-erlang");
require("prismjs/components/prism-dart");
require("prismjs/components/prism-csv");
require("prismjs/components/prism-cpp");
require("prismjs/components/prism-csharp");
require("prismjs/components/prism-coffeescript");
require("prismjs/components/prism-cmake");
require("prismjs/components/prism-bash");
require("prismjs/components/prism-markdown");
require("prismjs/components/prism-asciidoc");
require("prismjs/components/prism-typescript");
require("prismjs/components/prism-tsx");
require("prismjs/components/prism-wasm");
require("prismjs/components/prism-wiki");
require("prismjs/components/prism-wolfram");
require("prismjs/components/prism-xml-doc");
require("prismjs/components/prism-yaml");
require("prismjs/components/prism-zig");
const collectChildren = (children, tokens) => {
    const length = children.length;
    for (let i = 0; i < length; i++) {
        const child = children[i];
        if (typeof child === 'string') {
            const len = child.length;
            tokens.push(len);
        }
        else if (child instanceof prism.Token) {
            const token = [[child.type], []];
            const alias = child.alias;
            if (alias) {
                if (typeof child.alias === 'string')
                    token[0].push(child.alias);
                else if (alias instanceof Array)
                    token[0].push(...child.alias);
            }
            tokens.push(token);
            let content = child.content;
            if (content === 'string') {
                const len = content.length;
                token[1][0] = len;
            }
            else {
                if (!(content instanceof Array))
                    content = [content];
                collectChildren(content, token[1]);
            }
        }
    }
};
const highlight = (code, lang) => {
    var _a;
    lang = lang.toLowerCase();
    const grammar = (_a = prism.languages[lang]) !== null && _a !== void 0 ? _a : prism.languages[(lang = 'c')];
    const children = prism.tokenize(code, grammar);
    const token = [['language-' + lang], []];
    collectChildren(children, token[1]);
    return token;
};
exports.highlight = highlight;
const printToken0 = (tab, str, token, offset) => {
    if (typeof token === 'number')
        return ['(' + offset + ',' + token + '): ' + JSON.stringify(str.slice(offset, offset + token)), offset + token];
    const [type, children] = token;
    return [
        type.join(', ') +
            (0, printTree_1.printTree)(tab, children.map((child) => (tab) => {
                const p = printToken0(tab, str, child, offset);
                offset = p[1];
                return p[0];
            })),
        offset,
    ];
};
const print = (str, token) => printToken0('', str, token, 0)[0];
exports.print = print;
//# sourceMappingURL=highlight.js.map